<?php
/*  Copyright 2009  Alexandre Hoyau  (email : lex [at] silex-ria . org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/**
 * @package exchange-platform
 * @author http://lex.silex.tv/
 * @version 1
 */
/**
 * class used to manage the database of files stored in the exchange platforme and determine dependencies between elements
 */
class EPDataBase
{
	/**
	 * table name 
	 */
	public static $table_name;
	/**
	 * init allready done 
	 */
	public static $initDone = false;
	/**
	 * create the database if needed
	 */
	public static function initDB()
	{
		global $wpdb;
		
		if ($initDone == true) return;
		$initDone = true;
		
		EPDataBase::$table_name = $wpdb->prefix . 'exchange_platform_files';
		if($wpdb->get_var("show tables like '$table_name'") != EPDataBase::$table_name) 
		{
			$sql = "CREATE TABLE `".EPDataBase::$table_name."` (
			`id` INT NOT NULL AUTO_INCREMENT,
			`path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
			`postID` BIGINT( 20 ) NOT NULL ,
			`lastUpdate` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
			`userID` BIGINT( 20 ) NULL ,
			UNIQUE KEY id (id) ,
			INDEX ( `postID` )
			);";
			$wpdb->query($sql);
		}
	}
	public static function getPostIDForFile($filePath)
	{
		global $wpdb;
		$filePath = str_replace('/','_',$filePath);
		$filePath = str_replace('\\','_',$filePath);
		$postID = $wpdb->get_var($wpdb->prepare("SELECT `postID` FROM `".EPDataBase::$table_name."` WHERE `path` like '".$filePath."';"));
		return $postID;
	}
	public static function removeAllFiles($postID)
	{
		global $wpdb;
	//	if($postID!=null && $postID!='')
		$wpdb->query("DELETE FROM `".EPDataBase::$table_name."` WHERE `postID` = ".$postID.";");
		
//		$wpdb->query("DELETE FROM `wordpress_exchange-platform`.`wp_exchange_platform_1_exchange_platform_files` WHERE `wp_exchange_platform_1_exchange_platform_files`.`postID` = ".$postID.";");
	}
	public static function addFile($filePath,$postID)
	{
		global $wpdb;
		$wpdb->insert( EPDataBase::$table_name, array( 'path' => EPDataBase::sanitize($filePath), 'postID' => $postID));
	}
	public static function sanitize($str)
	{
		$forbidden=array("<", // HTML + logical operator
		 ">", // HTML + logical operator
		 "'", // SQL string operator
		 "\"", // SQL string operator
		 "%", // SQL string operator
		 "*",  
		 "", 
		 "`", 
		 "=");
		for ($i=0; $i<count($forbidden); $i++) 
		{	
			 $str=str_replace($forbidden[$i],"",$str);
		}
		return ($str);
	}
}
// never called?!
function EPDataBaseInitDB()
{
	EPDataBase::initDB();
	echo ' ------------------------------ '.EPDataBase::$table_name;
}
register_activation_hook(__FILE__,EPDataBaseInitDB);

//EPDataBase::removeAllFiles('0');
?>