<?php
/*  Copyright 2009  Alexandre Hoyau  (email : lex [at] silex-ria . org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/**
 * @package exchange-platform
 * @author http://lex.silex.tv/
 * @version 1
 */

// edit post page
define( 'EP_EDIT_PAGE_LABEL', 'Exchange Platform');

// admin page constants
define( 'EP_ADMIN_PAGE_LABEL', 'Exchange Platform');
define( 'FLOG_ADMIN_PAGE_TOOL_TIP','Exchange Platform options');
define( 'EP_ADMIN_PAGE_DEEP_LINK','exchange-platform-admin-page');
define( 'EP_ADMIN_PAGE_ID','exchange-platform_options');
define( 'EP_ADMIN_PAGE_POSITION',8);

// compute plugin name
if ( ! defined( 'EP_PLUGIN_NAME' ) ){
	$full_path = str_replace('\\','/',__FILE__);
	$start=strlen(WP_PLUGIN_DIR) + 1;
	$len=strrpos($full_path,basename(__FILE__)) - $start - strlen('includes') - 2;
	$pluginName = substr(__FILE__,$start,$len);

	define( 'EP_PLUGIN_NAME', $pluginName);
}
// folder, plugin and themes names
//if ( ! defined( 'SILEX_PAGE_TEMPLATES_DIR_NAME' ) )
//	define( 'SILEX_PAGE_TEMPLATES_DIR_NAME', 'page_templates' );

// URLs
if ( ! defined( 'WP_CONTENT_URL_MU_COMPATIBLE' ) ){
	if (defined('VHOST') && VHOST == 'no'){
		// wordpress mu with folders instead of subdomains
		$current_site = get_current_site();
		// remove the webstite subdomain (after the last slash - but for primaty blog)
		define( 'WP_CONTENT_URL_MU_COMPATIBLE',  substr(get_option( 'siteurl' ),0,strrpos(get_option( 'siteurl' ).'/',$current_site->path)+strlen($current_site->path)) . '/wp-content' );
	}
	else{
		// normal use (no sub folder)
		define( 'WP_CONTENT_URL_MU_COMPATIBLE', get_option( 'siteurl' ) . '/wp-content' );
	}
}
if ( ! defined( 'WP_CONTENT_URL' ) ){
	// lets try to define it
	// it is usually allready defined by wordpress
	define( 'WP_CONTENT_URL', WP_CONTENT_URL_MU_COMPATIBLE);
}

if ( ! defined( 'WP_PLUGIN_URL_MU_COMPATIBLE' ) ){
	define( 'WP_PLUGIN_URL_MU_COMPATIBLE', WP_CONTENT_URL_MU_COMPATIBLE.'/plugins' );
}
if ( ! defined( 'WP_PLUGIN_URL' ) ){
	// lets try to define it
	// it is usually allready defined by wordpress
	define( 'WP_PLUGIN_URL', WP_PLUGIN_URL_MU_COMPATIBLE );
}

//if ( ! defined( 'SILEX_THEME_URL' ) )
//	define( 'SILEX_THEME_URL', WP_PLUGIN_URL_MU_COMPATIBLE.'/'.SILEX_PLUGIN_NAME.'/'.SILEX_THEME_DIR_NAME );


// directories
if ( ! defined( 'WP_CONTENT_DIR' ) )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
      define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );

if ( ! defined( 'EP_PLUGIN_DIR' ) )
	define( 'EP_PLUGIN_DIR', WP_PLUGIN_DIR.'/'.EP_PLUGIN_NAME );
if ( ! defined( 'EP_INCLUDE_DIR' ) )
	define( 'EP_INCLUDE_DIR', EP_PLUGIN_DIR.'/includes' );

// params
define( 'EP_TEMP_DIR', EP_PLUGIN_DIR.'/temp');
// define EP_SECURE_OFFLINE_FOLDER_DIR as empty for security resons
// define( 'EP_SECURE_OFFLINE_FOLDER_DIR', '');
//define( 'EP_SECURE_OFFLINE_FOLDER_DIR', EP_PLUGIN_DIR.'/test_secure_directory');
define( 'EP_ONLINE_DOWNLOADS_DIR', EP_PLUGIN_DIR.'/downloads');


?>