<?php

require_once(EP_PLUGIN_DIR.'/includes/EPConfig.php');

/**
 * display a project details
 * @attribute
 */
function the_projects()
{
	global $epConfig;
	echo '<strong>'.count($epConfig->projectArray).' projects supported by your platform</strong>';
	for($idx=0;$idx<count($epConfig->projectArray);$idx++) {
?>
<br />
		<table class="widefat">
			<thead>
			<tr>
				<th WIDTH="50%">
					<form method="post" action="">
						<input type="hidden" name="epDeleteProject" value="<?php echo $idx; ?>" />			
						<?php echo $epConfig->projectArray[$idx]; ?><input type="submit" class="button-primary" value="<?php _e('Delete'); ?>" />
					</form>
				</th>
				<th WIDTH="50%">
					<form method="post" action="">
						<input type="hidden" name="epAddVersionIdx" value="<?php echo $idx; ?>" />			
						Add a version <input type="text" name="epAddVersion" value="" />
					<input type="submit" class="button-primary" value="<?php _e('Add'); ?>" />
					</form>
				</th>
			</tr>
			</thead>
			<tbody>
				<?php the_versions($idx, $epConfig->versionArray[$idx]); ?>
			</tbody>
		</table>
<?php
	}
}

/**
 * display a project versions
 * @attribute	$idx	index in the versions array
 * @attribute	
 */
function the_versions($idxProject, $versions)
{
	//$versions = preg_split('/,/',$versionsString);
	
	// display the versions and a remove button
	for($idxVersion=0;$idxVersion<count($versions);$idxVersion++) {
	?>
	<tr>
		<form method="post" action="">
			<input type="hidden" name="epDeleteVersion" value="<?php echo $idxProject; ?>-<?php echo $idxVersion; ?>">
			<td><?php echo $versions[$idxVersion]; ?></td>
			<td><input type="submit" class="button-secondary" value="<?php _e('Delete'); ?>" /></td>
		</form>
	</tr>
	<?php
	}
}

/**
 * add the options to the admin panel
 */ 
function epConfigAdmin() {
	//create new top-level menu
	add_options_page(FLOG_ADMIN_PAGE_TOOL_TIP, EP_ADMIN_PAGE_LABEL, 'manage_options', EP_ADMIN_PAGE_DEEP_LINK, epConfigAdminHtml);
}

/**
 * display the options
 */ 
function epConfigAdminHtml() {
	global $epConfig;
	$epSecureOfflineFolderDir = $epConfig->epSecureOfflineFolderDir;
	$epAllowedFoldersArray = implode(',',$epConfig->epAllowedFoldersArray);
	?>
		<div id="icon-tools" class="icon32"></div>
		<div class="wrap">
			<h2>Exchange Platform Settings</h2>
			<h3>About the exchange platform plugin</h3>
			<p>
				Convert your WordPress blog into a collaborative exchange platform. It is used on <a href="http://exchange.silexlabs.org/">the exchange platform</a> of <a href="http://www.silexlabs.org/">Silex Labs</a> in order to let people provide plugins, themes, addons to the organization's projects, AMFPHP, Silex, Flog, Oof.
			</p><p>
				In Silex, the installation and update of the elements taken from the exchange platform is automatic. This is made possible by the use of this WordPress exchange platform plugin with the Silex exchange platform plugin, also free and open source, and distributed on <a href="http://exchange.silexlabs.org/">the exchange platform</a> of <a href="http://www.silexlabs.org/">Silex Labs</a> of course!
			</p>
		<form method="post" action="">
			<?php settings_fields('epConfigAdminHtml'); ?>
			<h3>Configuration settings</h3>
			<hr />
			<h4>Secure folder path</h4>
			<p>
				<br /><input type="text" name="epSecureOfflineFolderDir" value="<?php echo $epSecureOfflineFolderDir; ?>" size="200" /><input type="submit" class="button-primary" value="<?php _e('Update') ?>" /><br /><br />
			</p>
			<p>
				used to store the unziped files, which have been uplaoded by the users.
			</p><p>
				This folder should <strong>not</strong> be accessible online, the elements in it will be accessed through the download service, so that php files are not executed.
			</p><p>
				For example this could have the value, with a trailing slash or not<br />
				<i>C:\Users\lexa\Documents\repositories\exchange platform\download_folder</i>
			</p><p>
				Or this for linux or Mac servers<br />
				<i>/homez/silex/silex-updater/exchange-platform/</i>
			</p>
			<h4>Allowed folders</h4>
			<p>
				<br /><input type="text" name="epAllowedFoldersArray" value="<?php echo $epAllowedFoldersArray; ?>" size="200" /><input type="submit" class="button-primary" value="<?php _e('Update') ?>" /><br /><br />
			</p>
			<p>
				Here is a list of the folders which you expect at the root of the zip files uploaded by the developpers. It is a list of folder names, coma separated. 
			</p><p>
				For example this has these values for Silex Labs platform
				<i>cgi,conf,contents,contents_themes,contents_utilities,fonts,lang,layouts,loaders,media,plugins,templates,tools</i>
			</p>
		</form>
		<hr />
		<form method="post" action="">
			<h4>Projects and versions</h4>
			<p>
				Here is where you can set up which projects/products are available on your platform. 
			</p>
			<p>
				<br /><strong>Add a project</strong><br /><input type="text" name="epAddProject" value="" size="200" /><input type="submit" class="button-primary" value="<?php _e('Add') ?>" /><br /><br />
			</p></form>
		<?php
		// display the projects and versions
		the_projects();
		?>
			<p>
				The developpers will be able to choose one for each element they will put for the end users to download. And then they will be asked to choose the versions of the project they target. 
			</p><p>
				Here is a drawing to illustrate what these lists do:<br />
				<div align="center">
					<img src="<?php echo WP_PLUGIN_URL . '/' . EP_PLUGIN_NAME . '/images/exchange1.png'; ?>" />
				</div>
			</p>
		
		<hr />
	<?php
}

/**
 * remove / add projects
 */
function doProjectManagementActions()
{
	global $epConfig;

	// remove a project
	if (isset($_POST['epDeleteProject']) && $_POST['epDeleteProject']!='')
	{
		$idxProject = $_POST['epDeleteProject'];
		// remove project
		array_splice($epConfig->projectArray, $idxProject, 1);
		// remove versions
		array_splice($epConfig->versionArray, $idxProject, 1);
		// save the 2 arrays
		$epConfig->saveConfig();
	}

	// add a project
	if (isset($_POST['epAddProject']) && $_POST['epAddProject']!='')
	{
		array_push($epConfig->projectArray, $_POST['epAddProject']);
		$epConfig->saveConfig();
	}
}

/**
 * remove / add versions
 */
function doVersionManagementActions()
{
	global $epConfig;
	
	// add a version
	if (isset($_POST['epAddVersion']) && $_POST['epAddVersion']!='')
	{
		// add the version to the list
		$epConfig->versionArray[$_POST['epAddVersionIdx']][] = $_POST['epAddVersion'];
	}

	// remove a version
	if (isset($_POST['epDeleteVersion']) && $_POST['epDeleteVersion']!='')
	{
		// index array, 
		// $idxArray[0] = 1st element = project index, 
		// $idxArray[1] = 2d element = version index
		$idxArray = preg_split('/-/',$_POST['epDeleteVersion']);
		// retrieve index of the project and the version we want to delete
		$idxProject = $idxArray[0];
		$idxVersion = $idxArray[1];
		// make an array of versions
		//$versionSplitedArray = preg_split('/,/',$epConfig->versionArray[$idxProject]);
		// delete the desired version
		array_splice($epConfig->versionArray[$idxProject], $idxVersion, 1);
		// store the result in the ep
		//$epConfig->versionArray[$idxProject] = $versionSplitedArray;
	}
	if (isset($_POST['epSecureOfflineFolderDir']) && $_POST['epSecureOfflineFolderDir']!='')
	{
		
		$epConfig->epSecureOfflineFolderDir = $_POST['epSecureOfflineFolderDir'];
	}
	if (isset($_POST['epAllowedFoldersArray']) && $_POST['epAllowedFoldersArray']!='')
	{
		
		$epConfig->epAllowedFoldersArray = explode(',',$_POST['epAllowedFoldersArray']);
	}
	// save in WP DB
	$epConfig->saveConfig();
}

// creation of the epConfig instance
global $epConfig;
$epConfig = new EPConfig(); 

// load config from wordpress config
$epConfig->loadConfig();

doProjectManagementActions();
doVersionManagementActions();

// the admin menu box settings
add_action('admin_menu', epConfigAdmin);

?>